Index: lib/TWiki/Func.pm
===================================================================
--- lib/TWiki/Func.pm	(revision 1767)
+++ lib/TWiki/Func.pm	(working copy)
@@ -63,7 +63,8 @@
 sub getSessionValue
 {
 #   my( $theKey ) = @_;
-    return &TWiki::getSessionValue( @_ );
+
+    return TWiki::Plugins::getSessionValueHandler( @_ );
 }
 
 
@@ -83,7 +84,7 @@
 sub setSessionValue
 {
 #   my( $theKey, $theValue ) = @_;
-    &TWiki::setSessionValue( @_ );
+    TWiki::Plugins::setSessionValueHandler( @_ );
 }
 
 # =========================
@@ -208,7 +209,7 @@
 # -------------------------
 sub getPubUrlPath
 {
-    return &TWiki::getPubUrlPath();
+    return $TWiki::pubUrlPath;
 }
 
 # =========================
@@ -230,10 +231,11 @@
 # =========================
 =pod
 
----+++ writeHeader( $query )
+---+++ writeHeader( $query, $contentLength )
 
 | Description:        | Prints a basic content-type HTML header for text/html to standard out |
 | Parameter: =$query= | CGI query object |
+  | Parameter: =$contentLength= | Length of content |
 | Return:             | none |
 | Since:              | TWiki::Plugins::VERSION 1.000 (7 Dec 2002) |
 
@@ -242,7 +244,7 @@
 sub writeHeader
 {
 #   my( $theQuery ) = @_;
-    return &TWiki::writeHeader( @_ );
+    return TWiki::writeHeader( @_ );
 }
 
 # =========================
@@ -525,7 +527,7 @@
 sub wikiToUserName
 {
 #   my( $wiki ) = @_;
-    return &TWiki::wikiToUserName( @_ );
+    return TWiki::User::wikiToUserName( @_ );
 }
 
 # =========================
@@ -544,7 +546,7 @@
 sub userToWikiName
 {
 #   my( $loginName, $dontAddWeb ) = @_;
-    return &TWiki::userToWikiName( @_ );
+    return &TWiki::User::userToWikiName( @_ );
 }
 
 # =========================
@@ -560,7 +562,7 @@
 # -------------------------
 sub isGuest
 {
-    return &TWiki::isGuest();
+    return ( $TWiki::userName eq $TWiki::defaultUserName );
 }
 
 # =========================
@@ -714,7 +716,7 @@
         my( $oopsUrl ) = checkTopicEditLock( $web, $topic );
         return $oopsUrl if( $oopsUrl );
     }
-    TWiki::Store::lockTopicNew( $web, $topic, ! $lock );    # reverse $lock parameter is correct!
+    TWiki::Store::lockTopic( $web, $topic, ! $lock );    # reverse $lock parameter is correct!
     return "";
 }
 
@@ -930,8 +932,9 @@
 # -------------------------
 sub internalLink
 {
-#   my( $pre, $web, $topic, $label, $anchor, $anchor, $createLink ) = @_;
-    return TWiki::Render::internalLink( @_ );
+    my $pre = shift;
+#   my( $web, $topic, $label, $anchor, $anchor, $createLink ) = @_;
+    return $pre . TWiki::Render::internalLink( @_ );
 }
 
 # =========================
@@ -1006,7 +1009,7 @@
 # -------------------------
 sub getDataDir
 {
-    return &TWiki::getDataDir();
+    return $TWiki::dataDir;
 }
 
 # =========================
@@ -1022,7 +1025,7 @@
 # -------------------------
 sub getPubDir
 {
-    return &TWiki::getPubDir();
+    return $TWiki::pubDir;
 }
 
 # =========================
Index: lib/TWiki/Store.pm
===================================================================
--- lib/TWiki/Store.pm	(revision 1767)
+++ lib/TWiki/Store.pm	(working copy)
@@ -30,7 +30,10 @@
 
 ---+ TWiki::Store Module
 
-This module hosts the generic storage backend.
+This module hosts the generic storage backend. This module should be the
+only module, anywhere, that knows that meta-data is stored interleaved
+in the topic text. This is so it can be easily replaced by alternative
+store implementations.
 
 =cut
 
@@ -38,6 +41,7 @@
 
 use File::Copy;
 use Time::Local;
+use TWiki::Meta;
 
 use strict;
 
@@ -46,65 +50,27 @@
 BEGIN {
     # Do a dynamic 'use locale' for this module
     if( $TWiki::useLocale ) {
-        require locale;
-	import locale ();
+        eval 'require locale; import locale ();';
     }
 }
 
-# FIXME: Move elsewhere?
-# template variable hash: (built from %TMPL:DEF{"key"}% ... %TMPL:END%)
-use vars qw( %templateVars ); # init in TWiki.pm so okay for modPerl
-
 # ===========================
 =pod
 
 ---++ sub initialize ()
 
-Not yet documented.
+Initialise the Store module, linking in the chosen implementation.
 
 =cut
 
 sub initialize
 {
-    %templateVars = ();
     eval "use TWiki::Store::$TWiki::storeTopicImpl;";
 }
 
-=pod
-
----++ sub _traceExec ()
-
-Normally writes no output, uncomment writeDebug line to get output of all RCS etc command to debug file
-
-=cut
-
-sub _traceExec
-{
-   #my( $cmd, $result ) = @_;
-   #TWiki::writeDebug( "Store exec: $cmd -> $result" );
-}
-
-=pod
-
----++ sub writeDebug ()
-
-Not yet documented.
-
-=cut
-
-sub writeDebug
-{
-   #TWiki::writeDebug( "Store: $_[0]" );
-}
-
-=pod
-
----++ sub _getTopicHandler (  $web, $topic, $attachment  )
-
-Not yet documented.
-
-=cut
-
+# PRIVATE sub _getTopicHandler (  $web, $topic, $attachment  )
+# Get the handler for the current store implementation, either RcsFile
+# or RcsLite
 sub _getTopicHandler
 {
    my( $web, $topic, $attachment ) = @_;
@@ -117,66 +83,15 @@
    return $handler;
 }
 
-
 =pod
 
----++ sub normalizeWebTopicName (  $theWeb, $theTopic  )
-
-Normalize a Web.TopicName
-<pre>
-Input:                      Return:
-  ( "Web",  "Topic" )         ( "Web",  "Topic" )
-  ( "",     "Topic" )         ( "Main", "Topic" )
-  ( "",     "" )              ( "Main", "WebHome" )
-  ( "",     "Web/Topic" )     ( "Web",  "Topic" )
-  ( "",     "Web.Topic" )     ( "Web",  "Topic" )
-  ( "Web1", "Web2.Topic" )    ( "Web2", "Topic" )
-</pre>
-Note: Function renamed from getWebTopic
-
-=cut
-
-sub normalizeWebTopicName
-{
-   my( $theWeb, $theTopic ) = @_;
-
-   if( $theTopic =~ m|^([^.]+)[\.\/](.*)$| ) {
-       $theWeb = $1;
-       $theTopic = $2;
-   }
-   $theWeb = $TWiki::webName unless( $theWeb );
-   $theTopic = $TWiki::topicName unless( $theTopic );
-
-   return( $theWeb, $theTopic );
-}
-
-
-=pod
-
----++ sub erase (  $web, $topic  )
-
-Get rid of a topic and its attachments completely
-Intended for TEST purposes.
-Use with GREAT CARE as file will be gone, including RCS history
-
-=cut
-
-sub erase
-{
-    my( $web, $topic ) = @_;
-
-    my $topicHandler = _getTopicHandler( $web, $topic );
-    $topicHandler->_delete();
-
-    writeLog( "erase", "$web.$topic", "" );
-}
-
-=pod
-
 ---++ sub moveAttachment (  $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment  )
 
-Move an attachment from one topic to another.
+Move an attachment from one topic to another. Meta-data is _not_ adjusted,
+this literally just moves the attachment.
+
 If there is a problem an error string is returned.
+
 The caller to this routine should check that all topics are valid and
 do lock on the topics.
 
@@ -185,49 +100,60 @@
 sub moveAttachment
 {
     my( $oldWeb, $oldTopic, $newWeb, $newTopic, $theAttachment ) = @_;
-    
+
+    # Remove file attachment from old topic
     my $topicHandler = _getTopicHandler( $oldWeb, $oldTopic, $theAttachment );
     my $error = $topicHandler->moveMe( $newWeb, $newTopic );
     return $error if( $error );
+}
 
-    # Remove file attachment from old topic
-    my( $meta, $text ) = readTopic( $oldWeb, $oldTopic );
-    my %fileAttachment = $meta->findOne( "FILEATTACHMENT", $theAttachment );
-    $meta->remove( "FILEATTACHMENT", $theAttachment );
-    $error .= saveNew( $oldWeb, $oldTopic, $text, $meta, "", "", "", "doUnlock", "dont notify", "" ); 
-    
-    # Remove lock file
-    $topicHandler->setLock( "" );
-    
-    # Add file attachment to new topic
-    ( $meta, $text ) = readTopic( $newWeb, $newTopic );
+=pod
 
-    $fileAttachment{"movefrom"} = "$oldWeb.$oldTopic";
-    $fileAttachment{"moveby"}   = $TWiki::userName;
-    $fileAttachment{"movedto"}  = "$newWeb.$newTopic";
-    $fileAttachment{"movedwhen"} = time();
-    $meta->put( "FILEATTACHMENT", %fileAttachment );    
-    
-    $error .= saveNew( $newWeb, $newTopic, $text, $meta, "", "", "", "doUnlock", "dont notify", "" ); 
-    # Remove lock file.
-    my $newTopicHandler = _getTopicHandler( $newWeb, $newTopic, $theAttachment );
-    $newTopicHandler->setLock( "" );
-    
-    writeLog( "move", "$oldWeb.$oldTopic", "Attachment $theAttachment moved to $newWeb.$newTopic" );
+---++ sub getAttachmentStream( $web, $topic, $attName )
+| =$web= | The web |
+| =$topic= | The topic |
+| =$attName= | Name of the attachment |
+Open a standard input stream from an attachment. Will return undef
+if the stream could not be opened (permissions, or nonexistant etc)
 
-    return $error;
+=cut
+
+sub getAttachmentStream {
+    #my ( $web, $topic, $att ) = @_;
+    my $topicHandler = _getTopicHandler( @_ );
+    my $strm;
+    my $fp = $topicHandler->{file};
+    if ( $fp ) {
+        unless ( open( $strm, "<$fp" )) {
+            TWiki::writeWarning( "File $fp open failed: error $!" );
+        }
+    }
+    return $strm;
 }
 
 =pod
 
----++ sub changeRefTo (  $text, $oldWeb, $oldTopic  )
+---++ sub attachmentExists( $web, $topic, $att ) -> boolean
 
-When moving a topic to another web, change within-web refs from this topic so that they'll work
-when the topic is in the new web. I have a feeling this shouldn't be in Store.pm.
+Determine if the attachment already exists on the given topic
 
 =cut
 
-sub changeRefTo
+sub attachmentExists {
+    #my ( $web, $topic, $att ) = @_;
+    my $topicHandler = _getTopicHandler( @_ );
+    return -e $topicHandler->{file};
+}
+
+# PRIVATE sub _changeRefTo (  $text, $oldWeb, $oldTopic  )
+# 
+# When moving a topic to another web, change within-web refs from
+# this topic so that they'll work when the topic is in the new web.
+# I have a feeling this shouldn't be in Store.pm.
+#
+# SMELL: It has to be - it knows about %META in topics. If you can
+# eliminate that dependency, then it could move somewhere else.
+sub _changeRefTo
 {
    my( $text, $oldWeb, $oldTopic ) = @_;
 
@@ -292,7 +218,10 @@
 
 ---++ sub renameTopic (  $oldWeb, $oldTopic, $newWeb, $newTopic, $doChangeRefTo  )
 
-Rename a topic, allowing for transfer between Webs
+Rename a topic, allowing for transfer between Webs. This method will change
+all references _from_ this topic to other topics _within the old web_
+so they still work after it has been moved to a new web.
+
 It is the responsibility of the caller to check for existence of webs,
 topics & lock taken for topic
 
@@ -313,18 +242,18 @@
          "to"   => "$newWeb.$newTopic",
          "date" => "$time",
          "by"   => "$user" );
-      my $fullText = readTopicRaw( $newWeb, $newTopic );
+      my $text = readTopicRaw( $newWeb, $newTopic );
       if( ( $oldWeb ne $newWeb ) && $doChangeRefTo ) {
-         $fullText = changeRefTo( $fullText, $oldWeb, $oldTopic );
+         $text = _changeRefTo( $text, $oldWeb, $oldTopic );
       }
-      my ( $meta, $text ) = _extractMetaData( $newWeb, $newTopic, $fullText );
+      my $meta = _extractMetaData( $newWeb, $newTopic, $text );
       $meta->put( "TOPICMOVED", @args );
-      saveNew( $newWeb, $newTopic, $text, $meta, "", "", "", "unlock" );
+      noHandlersSave( $newWeb, $newTopic, $text, $meta, "", "", "", "unlock" );
    }
    
    # Log rename
    if( $TWiki::doLogRename ) {
-      writeLog( "rename", "$oldWeb.$oldTopic", "moved to $newWeb.$newTopic $error" );
+      TWiki::writeLog( "rename", "$oldWeb.$oldTopic", "moved to $newWeb.$newTopic $error" );
    }
    
    # Remove old lock file
@@ -336,13 +265,13 @@
 
 =pod
 
----++ sub updateReferingPages (  $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs  )
+---++ sub updateReferringPages (  $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs  )
 
-Update pages that refer to the one being renamed/moved.
+Update pages that refer to a page that is being renamed/moved.
 
 =cut
 
-sub updateReferingPages
+sub updateReferringPages
 {
     my ( $oldWeb, $oldTopic, $wikiUserName, $newWeb, $newTopic, @refs ) = @_;
 
@@ -356,19 +285,19 @@
     while ( @refs ) {
        my $type = shift @refs;
        my $item = shift @refs;
-       my( $itemWeb, $itemTopic ) = TWiki::Store::normalizeWebTopicName( "", $item );
-       if ( &TWiki::Store::topicIsLockedBy( $itemWeb, $itemTopic ) ) {
+       my( $itemWeb, $itemTopic ) = TWiki::normalizeWebTopicName( "", $item );
+       if ( TWiki::Store::topicIsLockedBy( $itemWeb, $itemTopic ) ) {
           $lockFailure = 1;
        } else {
           my $resultText = "";
           $result .= ":$item: , "; 
           #open each file, replace $topic with $newTopic
-          if ( &TWiki::Store::topicExists($itemWeb, $itemTopic) ) { 
-             my $scantext = &TWiki::Store::readTopicRaw($itemWeb, $itemTopic);
-             if( ! &TWiki::Access::checkAccessPermission( "change", $wikiUserName, $scantext,
+          if ( TWiki::Store::topicExists($itemWeb, $itemTopic) ) { 
+             my $scantext = TWiki::Store::readTopicRaw($itemWeb, $itemTopic);
+             if( ! TWiki::Access::checkAccessPermission( "change", $wikiUserName, $scantext,
                     $itemWeb, $itemTopic ) ) {
                  # This shouldn't happen, as search will not return, but check to be on the safe side
-                 &TWiki::writeWarning( "rename: attempt to change $itemWeb.$itemTopic without permission" );
+                 TWiki::writeWarning( "rename: attempt to change $itemWeb.$itemTopic without permission" );
                  next;
              }
 	     my $insidePRE = 0;
@@ -407,8 +336,8 @@
 		}
 	        $resultText .= "$_\n";
 	     }
-	     my ( $meta, $text ) = &TWiki::Store::_extractMetaData( $itemWeb, $itemTopic, $resultText );
-	     &TWiki::Store::saveTopic( $itemWeb, $itemTopic, $text, $meta, "", "unlock", "dontNotify", "" );
+	     my $meta = _extractMetaData( $itemWeb, $itemTopic, $resultText );
+         saveTopic( $itemWeb, $itemTopic, $resultText, $meta, "", "unlock", "dontNotify", "" );
           } else {
 	    $result .= ";$item does not exist;";
           }
@@ -423,7 +352,7 @@
 ---++ sub readTopicVersion (  $theWeb, $theTopic, $theRev  )
 
 Read a specific version of a topic
-<pre>view:     $text= &TWiki::Store::readTopicVersion( $topic, "1.$rev" );</pre>
+<pre>view:     $text= TWiki::Store::readTopicVersion( $topic, "1.$rev" );</pre>
 
 =cut
 
@@ -431,21 +360,12 @@
 {
     my( $theWeb, $theTopic, $theRev ) = @_;
     my $text = _readVersionNoMeta( $theWeb, $theTopic, $theRev );
-    my $meta = "";
-   
-    ( $meta, $text ) = _extractMetaData( $theWeb, $theTopic, $text );
-        
+    my $meta = _extractMetaData( $theWeb, $theTopic, $text );
     return( $meta, $text );
 }
 
-=pod
+# Read a specific version of a topic
 
----++ sub _readVersionNoMeta (  $theWeb, $theTopic, $theRev  )
-
-Read a specific version of a topic
-
-=cut
-
 sub _readVersionNoMeta
 {
     my( $theWeb, $theTopic, $theRev ) = @_;
@@ -459,7 +379,7 @@
 
 ---++ sub readAttachmentVersion (  $theWeb, $theTopic, $theAttachment, $theRev  )
 
-Not yet documented.
+Read the given version of an attachment, returning the content.
 
 =cut
 
@@ -476,14 +396,16 @@
 
 ---++ sub getRevisionNumber (  $theWebName, $theTopic, $attachment  )
 
-Use meta information if available ...
+Get the revision number of the most recent revision.
 
+WORKS FOR ATTACHMENTS AS WELL AS TOPICS
+
 =cut
 
 sub getRevisionNumber
 {
     my( $theWebName, $theTopic, $attachment ) = @_;
-    my $ret = getRevisionNumberX( $theWebName, $theTopic, $attachment );
+    my $ret = _getMostRecentRevision( $theWebName, $theTopic, $attachment );
     ##TWiki::writeDebug( "Store: rev = $ret" );
     if( ! $ret ) {
        $ret = "1.1"; # Temporary
@@ -492,18 +414,13 @@
     return $ret;
 }
 
-
-=pod
-
----++ sub getRevisionNumberX (  $theWebName, $theTopic, $attachment  )
-
-Latest revision number. <br/>
-Returns "" if there is no revision.
-
-=cut
-
-sub getRevisionNumberX
-{
+# PRIVATE sub _getMostRecentRevision (  $theWebName, $theTopic, $attachment  )
+#
+# Latest revision number. <br/>
+# Returns "" if there is no revision.
+#
+# WORKS FOR ATTACHMENTS AS WELL AS TOPICS
+sub _getMostRecentRevision {
     my( $theWebName, $theTopic, $attachment ) = @_;
     if( ! $theWebName ) {
         $theWebName = $TWiki::webName;
@@ -511,7 +428,7 @@
     if( ! $attachment ) {
         $attachment = "";
     }
-    
+
     my $topicHandler = _getTopicHandler( $theWebName, $theTopic, $attachment );
     my $revs = $topicHandler->numRevisions();
     $revs = "1.$revs" if( $revs );
@@ -524,7 +441,7 @@
 ---++ sub getRevisionDiff (  $web, $topic, $rev1, $rev2, $contextLines  )
 
 <pre>
-rdiff:            $diffArray = &TWiki::Store::getRevisionDiff( $webName, $topic, "1.$r2", "1.$r1", 3 );
+rdiff:            $diffArray = TWiki::Store::getRevisionDiff( $webName, $topic, "1.$r2", "1.$r1", 3 );
 </pre>
 | Return: =\@diffArray= | reference to an array of [ diffType, $right, $left ] |
 
@@ -543,7 +460,6 @@
 
 
 # =========================
-# Call getRevisionInfoFromMeta for faster response for topics
 # FIXME try and get rid of this it's a mess
 # In direct calls changeToIsoDate always seems to be 1
 
@@ -596,7 +512,7 @@
     # pragmatic approach: Warn user if somebody else pressed the
     # edit link within a time limit e.g. 1 hour
 
-    ( $theWeb, $theTopic ) = normalizeWebTopicName( $theWeb, $theTopic );
+    ( $theWeb, $theTopic ) = TWiki::normalizeWebTopicName( $theWeb, $theTopic );
 
     my $lockFilename = "$TWiki::dataDir/$theWeb/$theTopic.lock";
     if( ( -e "$lockFilename" ) && ( $TWiki::editLockTime > 0 ) ) {
@@ -616,77 +532,58 @@
     return( "", 0 );
 }
 
+# ======================
+# Build a hash by parsing name=value comma separated pairs
 
-=pod
-
----++ sub keyValue2list (  $args  )
-
-Not yet documented.
-
-=cut
-
-sub keyValue2list
+sub _keyValue2Hash
 {
     my( $args ) = @_;
     
-    my @res = ();
+    my %res = ();
     
     # Format of data is name="value" name1="value1" [...]
-    while( $args =~ s/\s*([^=]+)=\"([^"]*)\"//o ) { #" avoid confusing syntax highlighters
-        push @res, $1;
-        push @res, $2;
+    while( $args =~ s/\s*([^=]+)=\"([^"]*)\"//o ) {
+        my $key = $1;
+        my $value = $2;
+        $value = TWiki::Meta::restoreValue( $value );
+        $res{$key} = $value;
     }
     
-    return @res;
+    return %res;
 }
 
 
-=pod
+# =pod
+# 
+# ---++ sub saveTopicNew (  $web, $topic, $text, $metaData, $saveCmd, $doUnlock, $dontNotify, $dontLogSave  )
+# 
+# Never called.
+# 
+# =cut
+# 
+# sub saveTopicNew
+# {
+#     my( $web, $topic, $text, $metaData, $saveCmd, $doUnlock, $dontNotify, $dontLogSave ) = @_;
+#     my $attachment = "";
+#     my $meta = TWiki::Meta->new();
+#     $meta->readArray( @$metaData );
+#     noHandlersSave( $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify );
+# }
 
----++ sub metaAddTopicData (  $web, $topic, $rev, $meta, $forceDate, $forceUser  )
-
-Not yet documented.
-
-=cut
-
-sub metaAddTopicData
-{
-    my( $web, $topic, $rev, $meta, $forceDate, $forceUser ) = @_;
-
-    my $time = $forceDate || time();
-    my $user = $forceUser || $TWiki::userName;
-
-    my @args = (
-       "version" => "$rev",
-       "date"    => "$time",
-       "author"  => "$user",
-       "format"  => $TWiki::formatVersion );
-    $meta->put( "TOPICINFO", @args );
-}
-
-
 =pod
 
----++ sub saveTopicNew (  $web, $topic, $text, $metaData, $saveCmd, $doUnlock, $dontNotify, $dontLogSave  )
-
-Not yet documented.
-
-=cut
-
-sub saveTopicNew
-{
-    my( $web, $topic, $text, $metaData, $saveCmd, $doUnlock, $dontNotify, $dontLogSave ) = @_;
-    my $attachment = "";
-    my $meta = TWiki::Meta->new();
-    $meta->readArray( @$metaData );
-    saveNew( $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify );
-}
-
-=pod
-
 ---++ sub saveTopic (  $web, $topic, $text, $meta, $saveCmd, $doUnlock, $dontNotify, $dontLogSave, $forceDate  )
+| =$web= | |
+| =$topic= | |
+| =$text= | |
+| =$meta= | |
+| =$saveCmd= | |
+| =$doUnlock= | |
+| =$dontNotify= | |
+| =$dontLogSave= | |
+| =$forceDate= | |
 
-Not yet documented.
+Save a new revision of the topic, calling plugins handlers as appropriate.
 
 =cut
 
@@ -696,24 +593,39 @@
     my $attachment = "";
     my $comment = "";
 
-    # FIXME: Inefficient code that hides meta data from Plugin callback
-    $text = $meta->write( $text );  # add meta data for Plugin callback
+    # SMELL: Staggeringly inefficient code that adds meta-data for
+    # Plugin callback. Why not simply pass the meta in? It would be far
+    # more sensible.
+    $text = _writeMeta( $meta, $text );  # add meta data for Plugin callback
     TWiki::Plugins::beforeSaveHandler( $text, $topic, $web );
-    $meta = TWiki::Meta->remove();  # remove all meta data
-    $text = $meta->read( $text );   # restore meta data
+    # remove meta data again!
+    $meta = _extractMetaData( $web, $topic, $text );
 
-    my $error = saveNew( $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $comment, $forceDate );
-    $text = $meta->write( $text );  # add meta data for Plugin callback
+    my $error = noHandlersSave( $web, $topic, $text, $meta, $saveCmd,
+                                $attachment, $dontLogSave, $doUnlock,
+                                $dontNotify, $comment, $forceDate );
+    $text = _writeMeta( $meta, $text );  # add meta data for Plugin callback
     TWiki::Plugins::afterSaveHandler( $text, $topic, $web, $error );
     return $error;
 }
 
 =pod
 
----++ sub saveAttachment ()
+---++ sub saveAttachment ($web, $topic, $text, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $theTmpFilename,
+        $forceDate)
+| =$web= | |
+| =$topic= | |
+| =$saveCmd= | |
+| =$attachment= | |
+| =$dontLogSave= | |
+| =$doUnlock= | |
+| =$dontNotify= | |
+| =$theComment= | |
+| =$theTmpFilename= | |
+| =$forceDate= | |
+Saves a new revision of the attachment, invoking plugin handlers as
+appropriate.
 
-Not yet documented.
-
 =cut
 
 sub saveAttachment
@@ -721,7 +633,7 @@
     my( $web, $topic, $text, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $theTmpFilename,
         $forceDate) = @_;
 
-    writeDebug("saveAttachment");
+    #TWiki::writeDebug("saveAttachment");
     my %attachmentAtt = ( attachment => $attachment,
                            tmpFilename => $theTmpFilename,
                            comment => $theComment,
@@ -731,6 +643,7 @@
     my $topicHandler = _getTopicHandler( $web, $topic, $attachment );
     TWiki::Plugins::beforeAttachmentSaveHandler( \%attachmentAtt, $topic, $web );
 
+    # SMELL: Not clear why this is so radically different to a topic save
     $theComment = $attachmentAtt{comment};
     my $error = $topicHandler->addRevision( $theTmpFilename, $theComment, $TWiki::userName );
     TWiki::Plugins::afterAttachmentSaveHandler( \%attachmentAtt, $topic, $web, $error );
@@ -741,58 +654,46 @@
 }
 
 
-=pod
-
----++ sub save (  $web, $topic, $text, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $forceDate  )
-
-Not yet documented.
-
-=cut
-
-sub save
-{
-    my( $web, $topic, $text, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $forceDate ) = @_;
-    
-    # FIXME get rid of this routine
-    
-    my $meta = TWiki::Meta->new();
-    
-    return saveNew( $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $forceDate );
-}
-
-
-=pod
-
----++ sub _addMeta (  $web, $topic, $text, $attachment, $nextRev, $meta, $forceDate, $forceUser  )
-
-Add meta data to the topic.
-
-=cut
-
+# PRIVATE sub _addMeta (  $web, $topic, $text, $attachment, $nextRev, $meta, $forceDate, $forceUser  )
+#
+# Add meta data to the topic.
 sub _addMeta
 {
     my( $web, $topic, $text, $attachment, $nextRev, $meta, $forceDate, $forceUser ) = @_;
-    
+
     if( ! $attachment ) {
         $nextRev = "1.1" if( ! $nextRev );
-        metaAddTopicData(  $web, $topic, $nextRev, $meta, $forceDate, $forceUser );
-        $text = $meta->write( $text );        
+        $meta->addTopicInfo(  $web, $topic, $nextRev, $forceDate, $forceUser );
+        $text = _writeMeta( $meta, $text );
     }
-    
+
     return $text;
 }
 
-
 =pod
 
----++ sub saveNew (  $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $forceDate  )
+---++ sub noHandlersSave (  $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $forceDate  )
+| =$web= | |
+| =$topic= | |
+| =$text= | |
+| =$meta= | |
+| =$saveCmd= | |
+| =$attachment= | |
+| =$dontLogSave= | |
+| =$doUnlock= | |
+| =$dontNotify= | |
+| =$theComment= | |
+| =$forceDate= | |
 
-Return non-null string if there is an (RCS) error. <br/>
+Save a topic or attachment _without_ invoking plugin handlers.
+
+Return non-null string if there is an (RCS) error.
+
 FIXME: does rev info from meta work if user saves a topic with no change?
 
 =cut
 
-sub saveNew
+sub noHandlersSave
 {
     my( $web, $topic, $text, $meta, $saveCmd, $attachment, $dontLogSave, $doUnlock, $dontNotify, $theComment, $forceDate ) = @_;
     my $time = time();
@@ -817,7 +718,7 @@
         # so add newline if needed
         $text =~ s/([^\n\r])$/$1\n/os;
     }
-    
+
     if( ! $theComment ) {
        $theComment = "none";
     }
@@ -859,7 +760,7 @@
                 $fdate = ""; # suppress warning
                 $fuser = ""; # suppress warning
 
-                my @foo = split( /\n/, &readFile( "$TWiki::dataDir/$TWiki::webName/.changes" ) );
+                my @foo = split( /\n/, readFile( "$TWiki::dataDir/$TWiki::webName/.changes" ) );
                 if( $#foo > 100 ) {
                     shift( @foo);
                 }
@@ -873,7 +774,7 @@
                 # write log entry
                 my $extra = "";
                 $extra   .= "dontNotify" if( $dontNotify );
-                writeLog( "save", "$TWiki::webName.$topic", $extra );
+                TWiki::writeLog( "save", "$TWiki::webName.$topic", $extra );
             }
         }
     }
@@ -899,11 +800,11 @@
         if( ( $TWiki::doLogTopicSave ) && ! ( $dontLogSave ) ) {
             # write log entry
             my $extra = "repRev $rev ";
-            $extra   .= &TWiki::userToWikiName( $user );
-            $date = &TWiki::formatTime( $epochSec, "rcs", "gmtime" );
+            $extra   .= TWiki::User::userToWikiName( $user );
+            $date = TWiki::formatTime( $epochSec, "rcs", "gmtime" );
             $extra   .= " $date";
             $extra   .= " dontNotify" if( $dontNotify );
-            writeLog( "save", "$TWiki::webName.$topic", $extra );
+            TWiki::writeLog( "save", "$TWiki::webName.$topic", $extra );
         }
     }
 
@@ -928,7 +829,7 @@
 
         if( $TWiki::doLogTopicSave ) {
             # write log entry
-            writeLog( "cmd", "$TWiki::webName.$topic", "delRev $rev" );
+            TWiki::writeLog( "cmd", "$TWiki::webName.$topic", "delRev $rev" );
         }
     }
     return ""; # all is well
@@ -936,46 +837,12 @@
 
 =pod
 
----++ sub writeLog (  $action, $webTopic, $extra, $user  )
-
-Not yet documented.
-
-=cut
-
-sub writeLog
-{
-    my( $action, $webTopic, $extra, $user ) = @_;
-
-    # use local time for log, not UTC (gmtime)
-
-    my ( $sec, $min, $hour, $mday, $mon, $year ) = localtime( time() );
-    my( $tmon) = $TWiki::isoMonth[$mon];
-    $year = sprintf( "%.4u", $year + 1900 );  # Y2K fix
-    my $time = sprintf( "%.2u ${tmon} %.2u - %.2u:%.2u", $mday, $year, $hour, $min );
-    my $yearmonth = sprintf( "%.4u%.2u", $year, $mon+1 );
-
-    my $wuserName = $user || $TWiki::userName;
-    $wuserName = &TWiki::userToWikiName( $wuserName );
-    my $remoteAddr = $ENV{'REMOTE_ADDR'} || "";
-    my $text = "| $time | $wuserName | $action | $webTopic | $extra | $remoteAddr |";
-
-    my $filename = $TWiki::logFilename;
-    $filename =~ s/%DATE%/$yearmonth/go;
-
-    if( open( FILE, ">>$filename" ) ) {
-         print FILE "$text\n";
-         close( FILE );
-    } else {
-         print STDERR "Couldn't write \"$text\" to $filename: $!\n";
-    }
-}
-
-=pod
-
 ---++ sub saveFile (  $name, $text  )
 
-Not yet documented.
+Save an arbitrary file
 
+SMELL: Breaks Store encapsulation.
+
 =cut
 
 sub saveFile
@@ -993,33 +860,17 @@
 
 =pod
 
----++ sub lockTopic (  $name, $doUnlock  )
+---++ sub lockTopic (  $theWeb, $theTopic, $doUnlock  )
 
-Not yet documented.
+Get a lock on the given topic.
 
 =cut
 
 sub lockTopic
 {
-   my ( $name, $doUnlock ) = @_;
-
-   lockTopicNew( $TWiki::webName, $name, $doUnlock );
-}
-
-=pod
-
----++ sub lockTopicNew (  $theWeb, $theTopic, $doUnlock  )
-
-Not yet documented. <br/>
-Called from rename and =TWiki::Func=
-
-=cut
-
-sub lockTopicNew
-{
     my( $theWeb, $theTopic, $doUnlock ) = @_;
 
-    ( $theWeb, $theTopic ) = normalizeWebTopicName( $theWeb, $theTopic );
+    ( $theWeb, $theTopic ) = TWiki::normalizeWebTopicName( $theWeb, $theTopic );
     
     my $topicHandler = _getTopicHandler( $theWeb, $theTopic );
     $topicHandler->setLock( ! $doUnlock );
@@ -1029,7 +880,10 @@
 
 ---++ sub removeObsoleteTopicLocks (  $web  )
 
-Not yet documented.
+Clean all obsolete .lock files in a web.
+This should be called regularly, best from a cron job
+(called from mailnotify). Only required for file database
+implementations of Store.
 
 =cut
 
@@ -1037,9 +891,6 @@
 {
     my( $web ) = @_;
 
-    # Clean all obsolete .lock files in a web.
-    # This should be called regularly, best from a cron job (called from mailnotify)
-
     my $webDir = "$TWiki::dataDir/$web";
     opendir( DIR, "$webDir" );
     my @fileList = grep /\.lock$/, readdir DIR;
